// dontkill.c

#include <windows.h>
#include <winsvc.h>
#include "custevnt.h"

HANDLE hLogOff;

LRESULT CALLBACK 
WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    switch (message) {
        case WM_ENDSESSION:
            SetEvent(hLogOff);
            return TRUE;

        case WM_DESTROY:      
            CloseHandle(hLogOff);
            PostQuitMessage(0);
            break;

        default:
            return (DefWindowProc(hWnd, message, wParam, lParam));
    }
    return 0;
}

int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                     LPSTR lpCmdLine, int nCmdShow)
{
    MSG       msg;
    WNDCLASS  wc;
    HWND      hWnd;

    wc.style         = CS_HREDRAW | CS_VREDRAW;
    wc.lpfnWndProc   = (WNDPROC)WndProc;
    wc.cbClsExtra    = 0;
    wc.cbWndExtra    = 0;
    wc.hInstance     = hInstance;
    wc.hIcon         = NULL;
    wc.hCursor       = NULL;
    wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
    wc.lpszMenuName  = NULL;
    wc.lpszClassName = TEXT("DontKill");
    RegisterClass(&wc);
    
    hLogOff = CreateEvent(NULL,FALSE,FALSE,CUSTOM_LOGOFF_EVENT); 

    hWnd = CreateWindow(TEXT("DontKill"),NULL,WS_OVERLAPPEDWINDOW,
                        CW_USEDEFAULT, 0, CW_USEDEFAULT, 0,
                        NULL, NULL, hInstance, NULL);
    
    while (GetMessage(&msg, NULL, 0, 0)) {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
   }

   return msg.wParam;
}

