#define UNICODE
#define _UNICODE

#include <windows.h>
#include "npapi.h"
#include "custevnt.h"

// The authentication type is only used here in a Unicode context

#define MSV1_0_AUTH_TYPE    L"MSV1_0:Interactive"

HANDLE hLogOn;

//-----------------------------------------------------------------
BOOL WINAPI DllMain(HANDLE hInst, DWORD dwReason, LPVOID lpRsrv)
{
    if(dwReason == DLL_PROCESS_ATTACH)  {
        hLogOn = CreateEvent(NULL,FALSE,FALSE,CUSTOM_LOGON_EVENT);
        DisableThreadLibraryCalls(hInst);
    }
    return TRUE;

} // DllMain


//-----------------------------------------------------------------
DWORD WINAPI NPGetCaps(DWORD nIndex)
{
    DWORD dwRes;

    // This entry point is called to query the provider. The nIndex
    // parameter specifies what information is being queried. For
    // credential managers, only the following index values apply.

    switch (nIndex) {
        
        
        case WNNC_NET_TYPE:
            
            // Return network type in hiword, subtye in loword.
            
            dwRes = 0xffff0000; // credential manager
            break;

        case WNNC_SPEC_VERSION:
            dwRes = WNNC_SPEC_VERSION51;  // Provider spec version
            break;

        case WNNC_DRIVER_VERSION:
            dwRes = 1;  // Version number of this provider
            break;


        case WNNC_START:
            
            // Return 0 if the provider won't start, 1 if provider
            // is already started, a value (in milliseconds) of 
            // how long we estimate it will take for this provider
            // to start, or 0xFFFFFFF to indicate start time is 
            // unkown.
            
            dwRes = 1;  // We are already "started"
            break;

        default:
            dwRes = 0;  // zero means we don't support this query
            break;
    }

    return dwRes;

} // NPGetCaps

//-----------------------------------------------------------------
DWORD WINAPI NPLogonNotify(PLUID lpLogonId, 
        LPCWSTR lpAuthentInfoType, LPVOID lpAuthentInfo,
        LPCWSTR lpPreviousAuthentInfoType, 
        LPVOID lpPreviousAuthentInfo, LPWSTR lpStationName,
        LPVOID StationHandle, LPWSTR  *lpLogonScript)
{
    TCHAR szBuf[1024];

    // This routine is called when a user logs on.  If the user
    // authentication fails here, the user will still be logged on
    // to the local machine.
    
    wsprintf(szBuf, L"lpAuthentInfoType=%s lpStationName=%s, %d\r\n",
             lpAuthentInfoType, lpStationName, GetCurrentProcessId());
    MessageBox(NULL,szBuf,TEXT("Wdj_NP"),MB_OK);

    // If the primary authenticator is not MSV1_0, return success. 
    
    if (lstrcmpiW(MSV1_0_AUTH_TYPE, lpAuthentInfoType)) {
        MessageBox(NULL,L"Authenticator is not MSV1_0 - Returning",
                   TEXT("Wdj_NP"), MB_OK);
        SetLastError(NO_ERROR);
        return NO_ERROR;
    }

    // Do something with the authentication information (depends on
    // primary authenticator) ...

    MessageBox(NULL,L"Authenticator is MSV1_0",TEXT("Wdj_NP"),MB_OK);

    // Use the logon script capability to start companion app. MPR
    // will free the allocated buffer.
    
    *lpLogonScript = LocalAlloc(LPTR,256);    
    lstrcpy(*lpLogonScript, L"dontkill");
    
    SetEvent(hLogOn);

    return NO_ERROR;
}

//-----------------------------------------------------------------
DWORD WINAPI NPPasswordChangeNotify(LPCWSTR lpAuthentInfoType,
    LPVOID lpAuthentInfo, LPCWSTR lpPreviousAuthentInfoType,
    LPVOID lpPreviousAuthentInfo, LPWSTR lpStationName,
    LPVOID StationHandle, DWORD dwChangeInfo)
{
    // Called to notify a credential manager provider of a password 
    // (authentication information) change for an account.
    
    return NO_ERROR;

} // NPPasswordChangeNotify

